#date_time_stopwatch
# Python script demonstrating date and timing functions
# LAST UPDATED by Andy French Dec 2017

#Import numpy and timing library
import time
import numpy as np

#Display greeting message
print(" The Python stopwatch")
print(" By Dr Andrew French. December 2017 \n")

#Display's today's date and time
t = time.strftime('%X %x %Z')
print(" The current time and date is " + t + "\n")

#Open text file to store timing data
file = open("timing_data.txt", "w")
file.write("Timing data recorded from " + t) 

#Stopwatch
input(" Press return to start stopwatch ")
#Store time since current epoch (1970?) in s
t0 = time.time()

#Determine elapsed time and store this is an array
input(" Press return to stop stopwatch, Press q to finish timings ")
total_time = time.time() - t0
time_data = [total_time]

#Write first elapsed time to text file, and also print to console
file.write( "\n" + str(total_time))
print("\n #1 Time elapsed is " + str(np.around(total_time,3)) + " seconds.")

#Loop stopwatch to enable split times to be recorded
stop = 0
n = 1
while stop == 0:
    r = input(" Press return to stop stopwatch ")
    if r=="q":
        stop = 1
    else:
        #Increment couner
        n = n + 1
        #Get new time and hence calculate elapsed time
        total_time = time.time() - t0
        #Calculate time interval
        dt = total_time - time_data[-1]
        #Append time_data array of elapsed times
        time_data.append(total_time)
        #Update text file and print current status to console
        file.write( "\n" + str(total_time))
        print("\n #" + str(n) + " Interval of " + str(np.around(dt,3)) + " seconds. Time elapsed is " + str(np.around(total_time,3)) + " seconds.")

#Print total time data
print("\n Full time data /s \n")
for i in range(0,len(time_data) ):
    print(" " + str(time_data[i]))

#Close timing data file
file.close()
    
#Wait for user input to close terminal window
input("\n Press return to close ")

#End of code
